
#include <iostream>
#include <string>		
#include <iomanip>
#include <fstream>
#include <stdlib.h>
#include <time.h>
#include "elevator.h"		

using namespace std;

typedef enum {up,down} direction;
const MaxFloors = 8;
const int MaxPassengers = 20;


Elevator::Elevator(short id, short floor){
    Elevator::id = id;
    for (int i=0;i<MaxFloors;i++)
      floorlist[i]=false;
    for (i=0;i<MaxPassengers;i++)
      PassengerList[i]=-1;
    if (floor%2==0)
        direct = up;
    else direct = down;
    CurrentFloor = floor;
    CurrentPassengers = 0;
}


short Elevator::GetFloor(){
    return CurrentFloor;
}

void Elevator::WhereAreYou(ofstream &outfile){
  outfile<<"\n\n============ STATUS OF ELEVATOR "<<id<<"=======\n";
  if (CurrentPassengers==0) 
    outfile<<"Elevator "<<id<<" is idle and on floor "<<CurrentFloor<<endl;
  else {
    outfile<<"Elevator "<<id<<" is on floor "<<CurrentFloor
        <<" and it is moving";
    if (direct==up)  
       outfile<<" up"<<endl;
    else 
        outfile<<" down"<<endl; 
    }
  if (CurrentPassengers!=0) 
    {outfile<<"\nCurrent Passenger List is \n";
     for (int i=0;i<MaxPassengers;i++)
      if (PassengerList[i]!=-1)
        outfile<<"Passenger "<<PassengerList[i]<<" is in the elevator\n";
    }
  else 
     outfile<<"Currently Elevator has no Passengers\n";
  
}

void Elevator::WhereAreYou(){
  cout<<"\n============ STATUS OF ELEVATOR "<<id<<"=======\n";
  if (CurrentPassengers==0) 
       {
    cout<<"Elevator "<<id<<" is idle and on floor "<<CurrentFloor
        <<" and it is ready to move";
    if (direct==up)  
       cout<<" up"<<endl;
    else 
        cout<<" down"<<endl; 
     }
  else {
    cout<<"Elevator "<<id<<" is on floor "<<CurrentFloor
        <<" and it is moving";
    if (direct==up)  
       cout<<" up"<<endl;
    else 
        cout<<" down"<<endl; 
  }
  if (CurrentPassengers!=0) 
    {cout<<"\nCurrent Passenger List is \n";
     for (int i=0;i<MaxPassengers;i++)
      if (PassengerList[i]!=-1)
        cout<<"Passenger "<<PassengerList[i]<<" is in the elevator\n";
    }
  else 
     cout<<"Currently Elevator has no Passengers\n";
  
}
 
/////////////////////////////////////////////////////  
void Elevator::MoveToNextFloor(){
  short i = CurrentFloor;
  while (floorlist[i]==false && i< MaxFloors)
     i++; 
  if (i==MaxFloors)
    { i=CurrentFloor;
      while (floorlist[i]==false && i>=0)
                i--; 
      if (i<0)
        CurrentFloor=0;
      else {CurrentFloor = i;floorlist[i]=false; direct=down;}
    }
  else
    {CurrentFloor = i; floorlist[i]=false; direct=up;}
}

/////////////////////////////////////////////////////  
void Elevator::DropPassengers(Passenger list[]){
  short nextfloor=-1, distance=MaxFloors;
  for (int i=0;i<MaxPassengers;i++)
    if (list[i].elevator==id)
        if (abs(list[i].destination-CurrentFloor)<distance)
           { distance = abs(list[i].destination-CurrentFloor);
             nextfloor = list[i].destination;
           }
  CurrentFloor = nextfloor;
  // dropoff all passengers who wants to go to that floor
  for (i=0;i<MaxPassengers;i++)
    if (list[i].elevator==id && list[i].destination==CurrentFloor)
       {list[i].status = 2; CurrentPassengers--;}// served 
       //include code here to adjust the internal passenger array
  // pick anyone who wants to go in the same direction from that floor
} 
 

/////////////////////////////////////////////////
void Elevator::PickPassengers(Passenger list[]){
   int i=CurrentPassengers; // passengerlist index
   int j=0,min,minfloor;
   if (direct==up)
     { min=0;minfloor=CurrentFloor;
       for (int j=0;j<MaxPassengers;j++)
         if (list[j].status==0 && list[j].origin-CurrentFloor>0 && list[j].origin-list[j].destination<min)
           { min = list[j].origin-CurrentFloor;
             minfloor = list[j].origin;
           }
      }
   else
      { min=0;minfloor=CurrentFloor;
       for (int j=0;j<MaxPassengers;j++)
         if (list[j].status==0 && CurrentFloor-list[j].origin>0 && CurrentFloor-list[j].origin<min)
           { min = CurrentFloor-list[j].origin;
             minfloor = list[j].origin;
           }
      }
    CurrentFloor=minfloor;
    for (j=0;j<MaxPassengers;j++)
      if (list[j].status==0 && list[j].origin==CurrentFloor && list[j].direct==direct)
        {list[j].status=1;PassengerList[i++]=j;CurrentPassengers++;
         cout<<"Elevator "<<id<<" is Picking Passenger "<<list[j].id
             <<" from floor "<<list[j].origin<<endl;
         list[j].elevator = id;
        }
    cout<<"The total number of passengers in elevator " << id <<" is " 
        <<CurrentPassengers<<endl<<endl;
}
           
  
