

#include <iostream>
#include <string>		
#include <iomanip>
#include <fstream>
#include <stdlib.h>
#include <time.h>	
#include "passenger.h"	

using namespace std;

typedef enum {up,down} direction;
const MaxFloors = 8;
const int MaxPassengers = 20;


////////////////////// PASSENGER DEFINITIONS /////////////////////
Passenger::Passenger(int id, short origin, short destination){
    Passenger::id = id;
    Passenger::origin = origin;
    Passenger::destination = destination;
    if (origin-destination>0)
      direct = down;
    else
      direct = up;
}

void Passenger::SetPassenger(int id, short origin, short destination){
    Passenger::id = id;
    Passenger::origin = origin;
    Passenger::destination = destination;
    if (origin == 0) 
      direct = up;
    else if (origin==MaxFloors-1)
      direct = down;
    else if (origin-destination>0)
      direct = down;
    else
      direct = up;
    status = 0;
}

void Passenger::ShowStatus(Elevator &x) {
  cout<<"\nPassenger "<<id<<" is ";
  if (status==0)
    cout<<"waiting in floor "<<origin;
  else if (status==1)
    cout<<"already being served and is on floor "<<destination;
  else
    cout<<"is currently in elevator "<<x.id;
}

void Passenger::ShowStatus(Elevator &x,ofstream &outfile) {
  outfile<<"\nPassenger "<<id<<" is ";
  if (status==0)
    {outfile<<"waiting in floor "<<origin <<" going "; 
     if (destination-origin > 0)  outfile <<" up";
     else outfile<<" down";
    }
  else if (status==1)
   {outfile<<"already being served and is on floor "<<destination;
   }  
  else
    outfile<<"is currently in elevator "<<x.id
           <<"going from " <<origin<<" to " << destination;
}
  
  


